unit About_Box;

interface

uses
  SysUtils, Classes,
{$ifdef Linux}
  QForms, QStdCtrls, QControls, QButtons, QGraphics, 
  QExtCtrls, libc, QDialogs, LibcExec
  ;
{$else}
  Forms, StdCtrls, Controls, Buttons, Graphics,
  ExtCtrls, ShellAPI, Dialogs;
{$endif}

type
  TAboutBox = class(TForm)
    Panel1: TPanel;
    Shadow: TLabel;
    ProgramIcon: TImage;
    ProductName: TLabel;
    Version: TLabel;
    Copyright: TLabel;
    OKButton: TButton;
    URL: TSpeedButton;
    MailAdress: TSpeedButton;
    OS_Shadow: TLabel;
    OS: TLabel;
    procedure FormShow(Sender: TObject);
    procedure OKButtonClick(Sender: TObject);
    procedure URLClick(Sender: TObject);
    procedure MailAdressClick(Sender: TObject);
  private
  public
    {$ifdef Linux}
    function LibcSystem(Command: String): Integer;
    {$endif}
  end;

var
  AboutBox: TAboutBox;

implementation

{$R *.xfm}

procedure TAboutBox.FormShow(Sender: TObject);
begin
  Shadow.Caption := ProductName.Caption;
  OS.Left        := ProductName.Left + ProductName.Width + 5;
  OS_Shadow.Left := OS.Left + 3;
end;

procedure TAboutBox.OKButtonClick(Sender: TObject);
begin
  Close;
end;

procedure TAboutBox.URLClick(Sender: TObject);
{$ifdef Linux}
var S: String;
{$endif}
begin
  {$ifdef Linux}
  S := GetEnvironmentVariable('HOME');
  if (DirectoryExists(S + '/.kde')) and (DirectoryExists(S + '/Desktop')) then
    if LibcSystem('kfmclient openURL "' + URL.Caption + '"') <> -1 then
      Exit;
  if LibcSystem('mozilla ' + URL.Caption) = -1 then
    if LibcSystem('netscape ' + URL.Caption) = -1 then
      ShowMessage('Sorry, cannot open a browser.');
  {$else}
  ShellExecute(Handle, 'Open', PChar(URL.Caption), nil, '', 0);//SW_SHOW);
  {$endif}
end;

procedure TAboutBox.MailAdressClick(Sender: TObject);
begin
  {$ifdef Linux}
  {$else}
  ShellExecute(Handle, 'Open', PChar('mailto:' + MailAdress.Caption + '?subject=' + Trim(ProductName.Caption)), nil, '', 0);//SW_SHOW);
  {$endif}
end;

{$ifdef Linux}
function TAboutBox.LibcSystem(Command: String): Integer;
var
  Str: array [0..250] of char;
begin
  StrPlCopy(Str, Command, 250);
  Result := Libc.system(Str);
end;
{$endif}
end.
