unit DataSeries_Dialog_for_Contour;

interface

uses
{$ifdef Linux}
  SysUtils, Classes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, QExtCtrls, QComCtrls, 
  MathsParser, QGrids, Types, QTypes, Qt, IniFiles, Math
  ;
{$else}
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, Spin, MathsParser, Grids, IniFiles, Math;
{$endif}

const
  NumRow = 78;

type
  TDataSeriesDialogForContour = class(TForm)
    cbXb: TComboBox;
    cbYl: TComboBox;
    Label2: TLabel;
    Label4: TLabel;
    Label7: TLabel;
    cbReadEnd: TComboBox;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Label10: TLabel;
    Label11: TLabel;
    cbLineStyle: TComboBox;
    Label12: TLabel;
    edLineWidth: TEdit;
    Panel1: TPanel;
    Label16: TLabel;
    Panel2: TPanel;
    OK: TButton;
    CancelButton: TButton;
    Panel3: TPanel;
    ColorDialog1: TColorDialog;
    Image1: TImage;
    Timer1: TTimer;
    Button1: TButton;
    ColorDialog2: TColorDialog;
    GroupBox5: TGroupBox;
    GroupBox6: TGroupBox;
    chkXconvert: TCheckBox;
    chkYconvert: TCheckBox;
    edXconverter: TEdit;
    edYconverter: TEdit;
    Parser: TMathsParser;
    StringGrid: TStringGrid;
    HelpButton: TButton;
    edReadStart: TEdit;
    Label21: TLabel;
    cbZ: TComboBox;
    Label1: TLabel;
    chkZconvert: TCheckBox;
    edZconverter: TEdit;
    GroupBox3: TGroupBox;
    Label3: TLabel;
    edMin: TEdit;
    Label5: TLabel;
    edMax: TEdit;
    Label6: TLabel;
    seDivision: TSpinEdit;
    chkLog: TCheckBox;
    Panel4: TPanel;
    Image2: TImage;
    Button2: TButton;
    Label8: TLabel;
    Timer2: TTimer;
    procedure FormShow(Sender: TObject);
    procedure cbXbChange(Sender: TObject);
    procedure cbYlChange(Sender: TObject);
    procedure OKClick(Sender: TObject);
    procedure cbReadEndKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Panel3Enter(Sender: TObject);
    procedure Panel3Exit(Sender: TObject);
    procedure Panel3MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure chkXconvertClick(Sender: TObject);
    procedure chkYconvertClick(Sender: TObject);
    procedure StringGridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure StringGridExit(Sender: TObject);
    procedure StringGridEnter(Sender: TObject);
    procedure HelpButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure cbZChange(Sender: TObject);
    procedure chkZconvertClick(Sender: TObject);
    procedure edZconverterChange(Sender: TObject);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel4Enter(Sender: TObject);
    procedure Panel4Exit(Sender: TObject);
    procedure Panel4MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Timer2Timer(Sender: TObject);
    procedure edMinChange(Sender: TObject);
  private
    function IsNumeral(S: String): Boolean;
    function DefColor: Integer;
    procedure FindMaxMin;
  public
    function SetLengthRJ(dumstr: String; dumint: Shortint): String;
  end;

var
  DataSeriesDialogForContour: TDataSeriesDialogForContour;
  SL1, SL2: TStringList;
  Msg: array[1..10] of String;
  MaxColWidth: array[1..NumRow] of Integer;
  LastIndex_of_cbXb, LastIndex_of_cbYl,  LastIndex_of_cbZ, NumItemsCB5: ShortInt;
  DefNumData: Integer;
  {$ifdef Linux}
  Gnome: Boolean;
  {$endif}

implementation

uses MainForm, DS_list;

{$R *.xfm}

procedure TDataSeriesDialogForContour.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  S, ResourceFileName: String;
  i: Integer;
  procedure GetComboBoxItems(CB: TComboBox );
  begin
    i := CB.ItemIndex;
    CB.Items.Text := StringReplace(IniFile.ReadString(S, CB.Name +  '.Items.Text', ''), '<br>', #13#10, [rfReplaceAll, rfIgnoreCase]);
    CB.ItemIndex := i;
  end;
begin
  Msg[1] := 'Properties of Data Series - ';
  S := Self.Name;
  ResourceFileName := ChangeFileExt(Application.ExeName, '.lng');
  Font.Assign(Main.Font);
  StringGrid.Font.Assign(Main.Font);
  if FileExists(ResourceFileName) then
  begin
    IniFile := TIniFile.Create(ResourceFileName);
    with IniFile do
      try
        GroupBox1.Caption        := ReadString(S, 'GroupBox1.Caption', '');
        GroupBox2.Caption        := ReadString(S, 'GroupBox2.Caption', '');
        GroupBox3.Caption        := ReadString(S, 'GroupBox3.Caption', '');
        GroupBox5.Caption        := ReadString(S, 'GroupBox5.Caption', '');
        GroupBox6.Caption        := ReadString(S, 'GroupBox6.Caption', '');
        Label1.Caption           := ReadString(S, 'Label1.Caption', '');
        Label6.Caption           := ReadString(S, 'Label6.Caption', '');
        Label7.Caption           := ReadString(S, 'Label7.Caption', '');
        Label8.Caption           := ReadString(S, 'Label8.Caption', '');
        Label10.Caption          := ReadString(S, 'Label10.Caption', '');
        Label11.Caption          := ReadString(S, 'Label11.Caption', '');
        Label12.Caption          := ReadString(S, 'Label12.Caption', '');
        Label16.Caption          := StringReplace(ReadString(S, 'Label16.Caption', ''), '<br>', #13#10, [rfReplaceAll, rfIgnoreCase]);
        Label21.Caption          := ReadString(S, 'Label21.Caption', '');
        chkXconvert.Caption      := ReadString(S, 'chkXconvert.Caption', '');
        chkYconvert.Caption      := ReadString(S, 'chkYconvert.Caption', '');
        chkZconvert.Caption      := ReadString(S, 'chkZconvert.Caption', '');
   //     chkSpline.Caption        := ReadString(S, 'chkSpline.Caption', '');
        chkLog.Caption           := ReadString(S, 'chkLog.Caption', '');
        CancelButton.Caption     := ReadString(S, 'CancelButton.Caption', '');
        HelpButton.Caption       := ReadString(S, 'HelpButton.Caption', '');
        cbReadEnd.Items.Strings[0] := ReadString(S, 'cbReadEnd.Items.Strings[0]', '');
        GetComboBoxItems(cbLineStyle);
        for i := 1 to 1 do
          Msg[i] := StringReplace(ReadString(S, 'Msg' + IntToStr(i), ''), '<br>', #13#10, [rfReplaceAll, rfIgnoreCase]);
      finally
        Free;
      end;
  end;
  if LANG = 128 then
  begin
    edReadStart.Left := Label7.Left;
    Label7.Left := Label7.Left + 35;
    cbReadEnd.Left := 90;
    Label12.Left := 195;
    Label21.Left := cbReadEnd.Left + cbReadEnd.Width;
  end;
  NumItemsCB5 := 0;
  SelectedDS := 1;
  {$ifdef Linux}
  Gnome := FileExists('/usr/bin/gnome-session');
  if Main.Font.Name = 'ricoh-gothic' then
    Gnome := True;
  {$endif}
end;

procedure TDataSeriesDialogForContour.FormShow(Sender: TObject);
var
  i, j, j2, k: Integer;
  S: String;
  SearchRec: TSearchRec;
begin
  ModalResult := mrNone;
  i := DS;
  if FindFirst(DataSeries[i], faAnyFile, SearchRec) = 0 then
    S := DateTimeToStr(FileDateToDateTime((SearchRec.Time)));
  Caption := Msg[1] + Main.GetRelativeDirectory(FigDir, DataSeries[i]) + ': ' + Copy(S, 0, Length(S) - 3);
  FindFirst(DataSeries[i], faAnyFile, SearchRec);
  FindClose(SearchRec);
  Main.Cursor := crDefault;
  cbXb.ItemIndex := Xb[i];
  cbYl.ItemIndex := Yl[i];
  cbZ.ItemIndex  := Z[i];
  if Zdivision[i] >= 0 then
    chkLog.Checked := False
  else
    chkLog.Checked := True;
  LastIndex_of_cbXb := cbXb.ItemIndex;
  LastIndex_of_cbYl := cbYl.ItemIndex;
  LastIndex_of_cbZ  := cbZ.ItemIndex;
  cbXbChange(Sender);
  cbYlChange(Sender);
  cbZChange(Sender);
  edReadStart.Text := IntToStr(ReadStart[i]);
  if ReadEnd[i] = 0 then
    cbReadEnd.ItemIndex := 0
  else
  begin
    if cbReadEnd.Items.IndexOf(IntToStr(ReadEnd[i])) = -1 then
    begin
      NumItemsCB5 := NumItemsCB5 + 1;
      cbReadEnd.Items.Add(IntToStr(ReadEnd[i]));
      cbReadEnd.ItemIndex := NumItemsCB5;
    end
    else
      cbReadEnd.ItemIndex := cbReadEnd.Items.IndexOf(IntToStr(ReadEnd[i]));
  end;
  {
  edXconverter.Text := FloatToStr(Xmult[i]);
  Memo3.Lines[0] := FloatToStr(Xoffset[i]);
  edYconverter.Text := FloatToStr(Ymult[i]);
  Memo5.Lines[0] := FloatToStr(Yoffset[i]);
  }
  edLineWidth.Text := FloatToStr(Round(10 * Line_Width[i]) / 10);
  edXconverter.Text := XConverter[i];
  edYconverter.Text := YConverter[i];
  edZconverter.Text := ZConverter[i];
  chkXconvertClick(Sender);
  chkYconvertClick(Sender);
  chkZconvertClick(Sender);
  if XConvert[i] = 0 then chkXconvert.Checked := False else chkXconvert.Checked := True;
  if YConvert[i] = 0 then chkYconvert.Checked := False else chkYconvert.Checked := True;
  if ZConvert[i] = 0 then chkZconvert.Checked := False else chkZconvert.Checked := True;
  edMax.Text := FloatToStr(Zmax[i]);
  edMin.Text := FloatToStr(Zmin[i]);
  seDivision.Value := Abs(Zdivision[i]);
  Panel3.Color := LineColor[i];
  Panel4.Color := MarkColor[i];
  Panel3Exit(Sender);
  {
  if NumLoadedData > 1 then
    cbDataLabels.Enabled := False
  else
    cbDataLabels.Enabled := True;
  }
  //--------------------
  for j := 1 to 200 do
    for k := 1 to NumRow do
      StringGrid.Cells[k,j] := '';
  SL1 := TStringList.Create;
  SL2 := TStringList.Create;
  i := DS;
  for j := 1 to NumRow do
    MaxColWidth[j] := 30;
  try
    {$ifdef Linux}
    {
    if Main.mmJconvert.Checked then
    begin
      Main.LibcSystem('nkf -e "' + DataSeries[i] + '" > ' + AppPath + 'temp.txt');
      SL1.LoadFromFile(AppPath + 'temp.txt');
      DeleteFile(AppPath + 'temp.txt');
    end
    else
    }
      SL1.LoadFromFile(DataSeries[i]);
    {$else}
    SL1.LoadFromFile(DataSeries[i]);
    {$endif}
    DefNumData := SL1.Count - 1;
    for i := 0 to SL1.Count - 1 do
    begin
      SL2.CommaText := SL1[i];
      for j := SL2.Count - 1 downto 0 do
      begin
        StringGrid.Cells[j+1,i+1] := SL2[j];
        //-- Detecting blank area (in the text line) which should be blank cell --//
        if j > 0 then
        begin
          if Pos(SL2[j], SL1[i]) > Pos(SL2[j-1], SL1[i]) + Length(SL2[j-1]) + 12 then
            if IsNumeral(SL2[j]) = False then
              if IsNumeral(SL2[j-1]) = False then
              begin
                for j2 := NumRow downto j + 3 do
                  StringGrid.Cells[j2,i+1] := StringGrid.Cells[j2-1,i+1];
                StringGrid.Cells[j+2,i+1] := SL2[j];
                StringGrid.Cells[j+1,i+1] := '';
              end;
        end
        else
        begin
          if Pos(SL2[0], SL1[i]) > 10 then
            if IsNumeral(SL2[0]) = False then
              begin
                for j2 := NumRow downto 3 do
                  StringGrid.Cells[j2,i+1] := StringGrid.Cells[j2-1,i+1];
                StringGrid.Cells[2,i+1] := SL2[0];
                StringGrid.Cells[1,i+1] := '';
              end;
        end;
      end;
      for j := 0 to 25 do
        if (StringGrid.Font.Size * Length(StringGrid.Cells[j+1,i+1])) div 2 + 20 > MaxColWidth[j+1] then
          MaxColWidth[j+1] := 30 + 20 + (StringGrid.Font.Size * Length(StringGrid.Cells[j+1,i+1])) div 2;
    end;
    StringGrid.RowCount := SL1.Count + 1;
  finally
    SL1.Free;
    SL2.Free;
  end;
  with StringGrid do
  begin
    DefaultDrawing := True;
    ColWidths[0] := 30;
    for i := 1 to RowCount + 1 do
    begin
      S := IntToStr(i);
      j2 := 5 - Length(S);
      {$ifdef Linux}
      if Gnome then
        j2 := j2 div 2;
      {$endif}
      for j := 1 to j2 do
        S :=  ' '  + S;
      Cells[0,i] := S;
    end;
    SetFocus;
  end;
  for j := 1 to NumRow do
  begin
    StringGrid.ColWidths[j] := MaxColWidth[j];
    if j <= 26 then
    begin
      S := Char(64 + j);
      k := 0;
    end
    else
      if j <= 52 then
      begin
        S := 'A' + Char(64 + j - 26);
        k := -1;
      end
      else
      begin
        S := 'B' + Char(64 + j - 52);
        k := -1;
      end;
    j2 := k + StringGrid.ColWidths[j] div StringGrid.Font.Size;
    {$ifdef Linux}
    if Gnome then
      j2 := j2 div 2;
    {$endif}
    for i := 1 to j2 do
      S := ' ' + S;
   // StringGridDrawCell(Sender, 2, 2, );
    StringGrid.Cells[j,0] := S;
  end;
  if cbXb.ItemIndex <> 0 then
    cbXb.Color := 11599792
  else
    cbXb.Color := clWhite;
  if cbYl.ItemIndex <> 0 then
    cbYl.Color := 16777130
  else
    cbYl.Color := clWhite;
  if cbZ.ItemIndex <> 0 then
    cbZ.Color := clYellow
  else
    cbZ.Color := clWhite;
  //StringGridEnter(Sender);
  i := DS;
  if (not NewDataSeries) or (DefNumData > 10) then
    LineStyle[i] := ((LineStyle[i] + 1) mod 6) - 1
  else
    LineStyle[i] := 0;
  cbLineStyle.ItemIndex := LineStyle[i];
  {
  if StringGrid.Font.charset = fcsUnicode then
    ShowMessage('fcsUnicode')
  else
    ShowMessage('not fcsUnicode');
  ShowMessage(StringGrid.Font.Name);
  }
end;

function TDataSeriesDialogForContour.IsNumeral(S: String): Boolean;
var d: Double;
begin
  try
    d := StrToFloat(S);
    if d > 0 then ;
    Result := True;
  except
    Result := False;
  end;
end;

procedure TDataSeriesDialogForContour.StringGridDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var
  {$ifdef Linux}
  i: Integer;
  {$endif}
  DoIt: Boolean;
begin
  DoIt := False;
  {$ifdef Linux}
  i := StrToInt(edReadStart.Text);
  if (ACol > 0) and (ARow > 0) and (ARow < i + 7) then
  begin
  {$endif}
    if gdFocused in State then
      StringGrid.Canvas.DrawFocusRect(Rect);
    if (ACol > 0) and (ARow > 0) then
      with StringGrid.Canvas do
      begin
        Brush.Color := clWhite;
        DoIt := True;
      end;
    if (cbXb.ItemIndex > 0) and (ACol = cbXb.ItemIndex) and (ARow > 0) then
      with StringGrid.Canvas do
      begin
        Brush.Color := 11599792;
        DoIt := True;
      end;
    if (cbYl.ItemIndex > 0) and (ACol = cbYl.ItemIndex) and (ARow > 0) then
      with StringGrid.Canvas do
      begin
        Brush.Color := 16777130;
        DoIt := True;
      end;
    if (cbZ.ItemIndex > 0) and (ACol = cbZ.ItemIndex) and (ARow > 0) then
      with StringGrid.Canvas do
      begin
        Brush.Color := clYellow;
        DoIt := True;
      end;
    if DoIt then
      with StringGrid.Canvas do
      begin
        FillRect(Rect);
        try
          dum := StrToFloat(StringGrid.Cells[ACol,ARow]);
          {$ifdef MSWINDOWS}
          DrawText(Handle, PChar(StringGrid.Cells[ACol,ARow]), Length(StringGrid.Cells[ACol,ARow]), Rect, DT_RIGHT);
          {$else}
          TextOut(Rect.Left+2,Rect.Top+2,StringGrid.Cells[ACol,ARow]);
          {$endif}
        except
          TextOut(Rect.Left+2,Rect.Top+2,StringGrid.Cells[ACol,ARow]);
        end;
      end;
  {$ifdef Linux}
  end;
  {$endif}
end;

//----------------------------------------------------------

procedure TDataSeriesDialogForContour.cbXbChange(Sender: TObject);
var j: Integer;
begin
  if cbXb.ItemIndex <> 0 then
  begin
    cbXb.Color := 11599792 //11599792
  end
  else
    cbXb.Color := clWhite;
  if (cbYl.ItemIndex = cbXb.ItemIndex) and (cbYl.ItemIndex > 0) then
  begin
    if cbXb.ItemIndex = 2 then
      cbYl.ItemIndex := 1
    else
      cbYl.ItemIndex := cbXb.ItemIndex + 1;
    cbYlChange(Sender);
  end;
  for j := 1 to StringGrid.RowCount do
  begin
    if cbXb.ItemIndex < 53 then
      StringGrid.Cells[cbXb.ItemIndex,j]  := StringGrid.Cells[cbXb.ItemIndex,j];
    StringGrid.Cells[LastIndex_of_cbXb,j] := StringGrid.Cells[LastIndex_of_cbXb,j];
  end;
  if cbXb.ItemIndex < 53 then
    LastIndex_of_cbXb := cbXb.ItemIndex;
end;

procedure TDataSeriesDialogForContour.cbYlChange(Sender: TObject);
var j: Integer;
begin
  if cbYl.ItemIndex <> 0 then
  begin
    cbYl.Color := 16777130; // 16777130
  end
  else
    cbYl.Color := clWhite;
  if (cbXb.ItemIndex = cbYl.ItemIndex) and (cbXb.ItemIndex > 0) then
  begin
    if cbYl.ItemIndex = 2 then
      cbXb.ItemIndex := 1
    else
      cbXb.ItemIndex := cbYl.ItemIndex + 1;
    cbXbChange(Sender);
  end;
  for j := 1 to StringGrid.RowCount do
  begin
    StringGrid.Cells[cbYl.ItemIndex,j]    := StringGrid.Cells[cbYl.ItemIndex,j];
    StringGrid.Cells[LastIndex_of_cbYl,j] := StringGrid.Cells[LastIndex_of_cbYl,j];
  end;
  LastIndex_of_cbYl := cbYl.ItemIndex;
end;

procedure TDataSeriesDialogForContour.cbZChange(Sender: TObject);
var j: Integer;
begin
  if cbZ.ItemIndex <> 0 then
  begin
    cbZ.Color := clYellow; // 16777130
  end
  else
    cbZ.Color := clWhite;
  if (cbXb.ItemIndex = cbYl.ItemIndex) and (cbXb.ItemIndex > 0) then
  begin
    if cbZ.ItemIndex = 2 then
      cbXb.ItemIndex := 1
    else
      cbXb.ItemIndex := cbZ.ItemIndex - 1;
    cbXbChange(Sender);
  end;
  for j := 1 to StringGrid.RowCount do
  begin
    StringGrid.Cells[cbZ.ItemIndex,j]    := StringGrid.Cells[cbZ.ItemIndex,j];
    StringGrid.Cells[LastIndex_of_cbZ,j] := StringGrid.Cells[LastIndex_of_cbZ,j];
  end;
  LastIndex_of_cbZ := cbZ.ItemIndex;
  Z[DS]  := cbZ.ItemIndex;
  Main.LoadDataSeries;
  //if (Zmax[DS] = - 10000000000000) and (Zmin[DS] = 10000000000000) then
  if MarkColor[DS] = DefColor then
    FindMaxMin;
end;

procedure TDataSeriesDialogForContour.OKClick(Sender: TObject);
var
  i: Integer;
begin
  i := DS;
  Xb[i] := cbXb.ItemIndex;
  Yl[i] := cbYl.ItemIndex;
  Z[i]  := cbZ.ItemIndex;
  ReadStart[i] := StrToInt(edReadStart.Text);
  try
    ReadEnd[i] := StrToInt(cbReadEnd.Text);
  except
    ReadEnd[i] := 0
  end;
  LineStyle[i] := cbLineStyle.ItemIndex;
  Line_Width[i] := StrToFloat(edLineWidth.Text);
  {
  if edXconverter.Text = ''  then edXconverter.Text := ' 1';
  if edXconverter.Text = '-' then edXconverter.Text := '-1';
  if edYconverter.Text = ''  then edYconverter.Text := ' 1';
  if edYconverter.Text = '-' then edYconverter.Text := '-1';
  Xmult[i]   := StrToFloat(edXconverter.Text);
  Xoffset[i] := StrToFloat(Memo3.Lines[0]);
  Ymult[i]   := StrToFloat(edYconverter.Text);
  Yoffset[i] := StrToFloat(Memo5.Lines[0]);
  }
  if Pos('x', AnsiLowerCase(edXconverter.Text)) > 0 then
    XConverter[i] := edXconverter.Text;
  if Pos('y', AnsiLowerCase(edYconverter.Text)) > 0 then
    YConverter[i] := edYconverter.Text;
  if Pos('z', AnsiLowerCase(edYconverter.Text)) > 0 then
    ZConverter[i] := edZconverter.Text;
  if chkXconvert.Checked then
  begin
    XConvert[i] := 1;
    Parser.Expression := XConverter[i];    // Validation
  end
  else
   XConvert[i] := 0;
  if chkYconvert.Checked then
  begin
    YConvert[i] := 1;
    Parser.Expression := YConverter[i];
  end
  else
    YConvert[i] := 0;
  if chkZconvert.Checked then
  begin
    ZConvert[i] := 1;
    Parser.Expression := ZConverter[i];
  end
  else
    ZConvert[i] := 0;
  Zmax[i] := StrToFloat(edMax.Text);
  Zmin[i] := StrToFloat(edMin.Text);
  Zdivision[i] := seDivision.Value;
  if chkLog.Checked then
    Zdivision[i] := - Zdivision[i];
  Main.LoadDataSeries;
  Modified[NumFigure] := 1;
  ModalResult := mrOK;
end;
//----------------------------------------------------------

procedure TDataSeriesDialogForContour.cbReadEndKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  {$ifdef Linux}
  if key = Key_Return then
  {$else}
  if key = VK_RETURN then
  {$endif}
    if cbReadEnd.Items.IndexOf( cbReadEnd.Text ) = -1 then
    begin
      NumItemsCB5 := NumItemsCB5 + 1;
      cbReadEnd.Items.Add(cbReadEnd.Text);
      cbReadEnd.ItemIndex := NumItemsCB5;
    end;
end;
//----------------------------------------------------------
function TDataSeriesDialogForContour.SetLengthRJ(dumstr: String; dumint: Shortint): String;
var i: Shortint;
begin
  for i:=1 to dumint - Length(dumstr) do
    dumstr:=' '+ dumstr;
  Result := dumstr;
end;
//----------------------------------------------------------

procedure TDataSeriesDialogForContour.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  //if (ModalResult <> mrOK) and (ModalResult <> mrCancel) then
  //  SysUtils.Abort;
end;
//----------------------------------------------------------
procedure TDataSeriesDialogForContour.Panel3Enter(Sender: TObject);
begin
  With Image1.Canvas do
  begin
    Pen.Color := clYellow;
    Pen.Style := psDot;
    Brush.Color := Panel3.Color;
    Rectangle(0, 0, Image1.Width, Image1.Height);
    OK.Default := False;
  end;
end;

procedure TDataSeriesDialogForContour.Panel3Exit(Sender: TObject);
begin
  With Image1.Canvas do
  begin
    Pen.Color := Panel3.Color;
    Brush.Color := Panel3.Color;
    Rectangle(0, 0, Image1.Width, Image1.Height);
    OK.Default := True;
  end;
end;

procedure TDataSeriesDialogForContour.Panel3MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  Panel3Enter(Sender);
  Timer1.Enabled := True;
end;

procedure TDataSeriesDialogForContour.Image1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  Button1Click(Sender);
end;

procedure TDataSeriesDialogForContour.Panel4Enter(Sender: TObject);
begin
  With Image2.Canvas do
  begin
    Pen.Color := clYellow;
    Pen.Style := psDot;
    Brush.Color := Panel4.Color;
    Rectangle(0, 0, Image2.Width, Image2.Height);
    OK.Default := False;
  end;
end;

procedure TDataSeriesDialogForContour.Panel4Exit(Sender: TObject);
begin
  With Image2.Canvas do
  begin
    Pen.Color := Panel4.Color;
    Brush.Color := Panel4.Color;
    Rectangle(0, 0, Image2.Width, Image2.Height);
    OK.Default := True;
  end;
end;

procedure TDataSeriesDialogForContour.Panel4MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  Panel4Enter(Sender);
  Timer1.Enabled := True;
end;

procedure TDataSeriesDialogForContour.Image2MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  Button1Click(Button2);
end;

procedure TDataSeriesDialogForContour.Button1Click(Sender: TObject);
begin
  if Sender = Button1 then
    ColorDialog1.Color :=  LineColor[DS]
  else
    ColorDialog1.Color :=  MarkColor[DS];
  if ColorDialog1.Execute then
  begin
    if Sender = Button1 then
    begin
      Panel3.Color  := ColorDialog1.Color;
      LineColor[DS] := ColorDialog1.Color;
    end
    else
    begin
      Panel4.Color  := ColorDialog1.Color;
      MarkColor[DS] := ColorDialog1.Color;
    end;
    if MarkColor[DS] = DefColor then
    begin
      MarkColor[DS] := LineColor[DS];
    end;
  end;
 // ShowMessage(IntToStr(Panel3.Color));
  if Sender = Button1 then
    Panel3Exit(Sender)
  else
    Panel4Exit(Sender);
end;

function TDataSeriesDialogForContour.DefColor: Integer;
begin
  Case DS of
   1:Result := 0;        // black
   2:Result := 16711680; // blue
   3:Result := 33023;    // orange
   4:Result := 65280;    // lime
   5:Result := 255;      // red
   6:Result := 32896;    // olive
   7:Result := 65535;    // yellow
   8:Result := 32768;    // green
   9:Result := 16744576; // purple
  10:Result := 16711808; // aqua
  11:Result := 0;        // black
  12:Result := 16711680; // blue
  13:Result := 33023;    // orange
  14:Result := 65280;    // lime
  15:Result := 255;      // red
  16:Result := 32896;    // olive
  17:Result := 65535;    // yellow
  18:Result := 32768;    // green
  19:Result := 16744576; // purple
  20:Result := 16711808; // aqua
  else
    Result := 0;
  end;
end;

procedure TDataSeriesDialogForContour.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := False;
  Panel3Exit(Sender);
end;

procedure TDataSeriesDialogForContour.chkXconvertClick(Sender: TObject);
begin
  edXconverter.Enabled := chkXconvert.Checked;
end;

procedure TDataSeriesDialogForContour.chkYconvertClick(Sender: TObject);
begin
  edYconverter.Enabled := chkYconvert.Checked;
end;

procedure TDataSeriesDialogForContour.chkZconvertClick(Sender: TObject);
begin
  edZconverter.Enabled := chkZconvert.Checked;
end;

procedure TDataSeriesDialogForContour.StringGridExit(Sender: TObject);
begin
  StringGrid.DefaultDrawing := False;
end;

procedure TDataSeriesDialogForContour.StringGridEnter(Sender: TObject);
begin
  StringGrid.DefaultDrawing := True;
end;

procedure TDataSeriesDialogForContour.HelpButtonClick(Sender: TObject);
begin
  {$ifdef Linux}
  InvokeHelp;
  //Main.IndexClick(Sender);
  {$else}
  Keybd_Event(VK_F1, 0, 0, 0);
  {$endif}
end;

procedure TDataSeriesDialogForContour.CancelButtonClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TDataSeriesDialogForContour.FindMaxMin;
var
  i, dumint, dumint1, dumint2: Integer;
begin
  //Zmax[DS] := -10000000000000;
  //Zmin[DS] :=  10000000000000;
  for i := 1 to NumData[DS] do
  begin
    if GZ[DS,i] <> 12345678910 then
      Zmax[DS] := Max(Zmax[DS], GZ[DS,i]);
    Zmin[DS] := Min(Zmin[DS], GZ[DS,i]);
  end;
  dumint := Floor(log10(Abs(Zmax[DS] - Zmin[DS])));
  Zmax[DS] := Ceil (Zmax[DS] * Power(10, - dumint)) / Power(10, - dumint);
  Zmin[DS] := Floor(Zmin[DS] * Power(10, - dumint)) / Power(10, - dumint);
  dumint1 := Floor(Zmax[DS] * Power(10, - dumint));
  dumint2 := Floor(Zmin[DS] * Power(10, - dumint));
  Zdivision[DS] := dumint1 - dumint2;
  Case Zdivision[DS] of
   8: Zdivision[DS] := 4;
  10: Zdivision[DS] := 5;
  end;
  edMax.Text := FloatToStr(Zmax[DS]);
  edMin.Text := FloatToStr(Zmin[DS]);
  seDivision.Value := Abs(Zdivision[DS]);
end;

procedure TDataSeriesDialogForContour.edZconverterChange(Sender: TObject);
begin
  Main.LoadDataSeries;
  if MarkColor[DS] = DefColor then
    FindMaxMin;
end;

procedure TDataSeriesDialogForContour.Timer2Timer(Sender: TObject);
var
  i, n: Integer;
  d, Gmax_, Gmin_ : Double;
begin
  if (edMin.Text = '') or (edMin.Text = '-') then
    Exit;
  if (edMax.Text = '') or (edMax.Text = '-') then
    Exit;
  if (Pos('E', edMin.Text) > 1) and (StrToFloat(edMin.Text) = 1) then
    Exit;
  if (Pos('E', edMax.Text) > 1) and (StrToFloat(edMax.Text) = 1) then
    Exit;
  Gmin_ := 0;
  Gmax_ := 0;
  try
    Gmin_ := StrToFloat(edMin.Text);
    Gmax_ := StrToFloat(edMax.Text);
    {
    if Gmax_*Gmin_ <= 0 then
      CheckBox1.Enabled := True
    else
      begin
      CheckBox1.Enabled := False;
      GridLine[i] := 0;
      end;
    }
    if (Gmax_ = 0) and (Gmin_ = 0) then
      Exit;
    if (Gmax_ <= 0) or (Gmin_ <= 0) then
    begin
    //  Zdivision[i] := - Zdivision[i];
      ChkLog.Checked := False;
      ChkLog.Enabled := False;
    end
    else
      ChkLog.Enabled := True;
  except
    ;
  end;
  i := DS;
  Zdivision[i] := seDivision.Value;
  if ChkLog.Checked then
  begin
    Gmin_ := IntPower(10, Floor(log10(Gmin_ * 1.01)));
    Gmax_ := IntPower(10, Ceil(log10(Gmax_ * 0.99)));
    edMin.Text := FloatToStr(Gmin_);
    edMax.Text := FloatToStr(Gmax_);
    n := Zdivision[i];
    Zdivision[i] := Abs(Ceil(log10(Gmax_ * 0.99)) - Floor(log10(Gmin_*1.01)));
    if 2 * n = Zdivision[i] then
    begin
      Zdivision[i] := n;
    end;
  end
  else
  begin
    d := Abs(Gmax_ - Gmin_);
    if d > 0 then
    begin
      d := 100 * d * Power(10, Trunc(log10(d)));
   //   ShowMessage(IntToStr((Trunc(d) mod Gdivision[i])));
      while (Zdivision[i] > 2) and ((Trunc(d + 0.0000000000001) mod Zdivision[i]) > 0) do
        Dec(Zdivision[i]);
    end;
  end;
  seDivision.Value := Zdivision[i];
  Timer2.Enabled := False;
end;

procedure TDataSeriesDialogForContour.edMinChange(Sender: TObject);
begin
  Timer2.Enabled := True;
end;

end.
